<?php

namespace App\Http\Requests\Admin;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use App\Services\Interfaces\BannerRepositoryInterface;

class BannerRequest extends FormRequest
{
    //
    private BannerRepositoryInterface $bannerRepository;

    public function __construct(BannerRepositoryInterface $bannerRepository)
    {
        $this->bannerRepository = $bannerRepository;
    }
    
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = ['super_admin', 'admin'];
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('banners'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=
            [
                'status'=>[
                    'required',
                    'in:file,video,link'
                ],
                'link'=>[
                    'sometimes',
                    'nullable',
                    'url',
                    'required_if:status,==,link'
                ],
                'video'=>[
                    'sometimes',
                    'nullable',
                    'required_if:status,==,video',
                    'mimes:mp4'
                ],
                'file'=>[
                    'sometimes',
                    'nullable',
                    'required_if:status,==,file'
                ],
            ];
        foreach (languages() as $lang) {
            $lang_rules=[
                'name_'.$lang->local=> [
                    'required'
                ],
            ];
            $rules= array_merge($rules, $lang_rules);
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $attributes=
            [
                'status'=>__('banners.status'),
                'link'=>__('banners.link'),
                'video'=>__('banners.video'),
                'file'=>__('banners.file'),
            ];
        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local => __('banners.name').' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    
    }

    /**
     * Add some data to be validated
     */
    protected function prepareForValidation()
    {
        //
        $this->merge(['status'=> 'file']);
        /*if(1 != ($this->banner->id ?? 0)){
            $defaultBanner= $this->bannerRepository->getItemById(1);
            foreach (languages() as $lang) {
                $this->merge(['name_'.$lang->local=> $defaultBanner[$lang->local]->name ]);
            }
        }*/
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
